package com.example.chat.controller;

import com.example.chat.ChatApplication;
import com.example.chat.dao.chat.ChatMapper;
import com.example.chat.entity.Email;
import com.example.chat.entity.Result;
import com.example.chat.entity.User;
import com.example.chat.entity.chat.Message;
import com.example.chat.service.CodeCheck;
import com.example.chat.service.LoginService;
import com.example.chat.service.mail.MailUtil;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.IOException;

@CrossOrigin
@RestController
public class LoginController {
    @Autowired
    LoginService login;
    @Resource
    CodeCheck codeCheck;
    @Resource
    MailUtil mailUtil;



    @PostMapping("/login")
    public Result Login(@RequestBody User user) throws IOException {
        Result result = new Result();
        if (login.LoginCheck(user) != null) {

            result.setStatus(200);
            result.setResponseStr(login.LoginCheck(user));

        } else {
            result.setStatus(200);
            result.setResponseStr("No");
        }
        return result;
    }

    @PostMapping("/register")
    public Result Register(@RequestBody User user) throws IOException {
        System.out.println("被调用了");
        System.out.println("user是啥" + user);
        Result result = new Result();
        result.setStatus(login.Register(user));
        return result;
    }

    @PostMapping("/checkCode")
    public boolean checkCode(@RequestBody Email email) {
        System.out.println(email);
        return codeCheck.CheckCode(email.getEmail(), email.getCode());
    }

    @PostMapping("/sendCode")
    public void sendCode(@RequestBody Email email) {
        System.out.println(email.getEmail());
        mailUtil.sendMail(email.getEmail());
    }
}
