package com.example.chat.dao.chat;

import com.example.chat.dao.mybatis.MybatisSingleton;
import com.example.chat.entity.chat.Message;
import com.example.chat.entity.chat.UpdateMessage;
import org.apache.ibatis.session.SqlSession;
import org.springframework.stereotype.Repository;

import java.io.IOException;
import java.util.List;

@Repository
public class ChatMessage implements ChatMapper {
    @Override
    public void addMessage(Message message) throws IOException {
        SqlSession sqlSession = MybatisSingleton.getSqlSessionFactory().openSession();
        sqlSession.insert("dao.chat.Message.addMessage", message);
        sqlSession.commit();
        sqlSession.close();
    }

    @Override
    public void updateMessage(UpdateMessage updateMessage) throws IOException {
        SqlSession sqlSession = MybatisSingleton.getSqlSessionFactory().openSession();
        sqlSession.update("dao.chat.Message.updateMessage", updateMessage);
        sqlSession.commit();
        sqlSession.close();
    }

    @Override
    public List<Message> getMessage() throws IOException {
        List<Message> messageList;
        SqlSession sqlSession = MybatisSingleton.getSqlSessionFactory().openSession();
        messageList = sqlSession.selectList("dao.chat.Message.getMessage");
        sqlSession.close();
        return messageList;
    }

    @Override
    public void deleteMessage() {

    }
}
