package com.example.chat.jwt;

import com.example.chat.dao.redis.RedisUtil;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Component
public class TokenInterceptor implements HandlerInterceptor {
    @Resource(name = "tokenRedis")
    RedisUtil redisUtil;//注册服务

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) {
        System.out.println("触发拦截");
        String token = request.getHeader("Token");
//        System.out.println(token + "检查一下token是啥");
//        Enumeration<String> headerNames = request.getHeaderNames();
//        while (headerNames.hasMoreElements()) {
//            String headerName = headerNames.nextElement();
//            String headerValue = request.getHeader(headerName);
//            System.out.println(headerName + ": " + headerValue);
//        }
        try {
            if (request.getMethod().equals("OPTIONS")) {//检查是否为跨域请求
                return true;
            }

            response.setCharacterEncoding("utf-8");

            if (token != null) {
                String verifyToken = JWTUtil.verify(token);

                if (redisUtil.getRedis(verifyToken) != null) {
                    response.setStatus(200);//设置状态码为正常，即通过登录验证
                    System.out.println("通过拦截器");
                    return true;
                } else {
                    response.setStatus(401);
                    return false;//redis里没有token，即登录超时
                }
            } else {
                response.setStatus(402);
                return false;//请求头不带token
            }

        } catch (Exception exception) {
            response.setStatus(500);//发生了不可预测的错误
            throw new RuntimeException();
        }


    }
}
